VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "MessageDataList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Copyright (C) 1997-2010 Kei Sakamoto
' {t@Cyі{t@Cgč쐬vO
' fzz֎~܂B

'SbZ[Wf[^(܂͓ʃf[^)ǗRNVNX

'bZ[Wf[^(܂͓ʃf[^)ꗗ
Private colMessageDataList As New Collection

'NX̉
Private Sub Class_Terminate()
Dim i As Integer
    
    With colMessageDataList
        For i = 1 To .Count
            .Remove 1
        Next
    End With
    Set colMessageDataList = Nothing
End Sub

'bZ[Wf[^̒ǉ
Public Function Add(mname As String) As MessageData
Dim new_md As New MessageData

    new_md.Name = mname
    colMessageDataList.Add new_md, mname
    Set Add = new_md
End Function

'bZ[Wf[^̑
Public Function Count() As Integer
    Count = colMessageDataList.Count
End Function

Public Sub Delete(Index As Variant)
    colMessageDataList.Remove Index
End Sub

'bZ[Wf[^̌
Public Function Item(Index As Variant) As MessageData
    On Error GoTo ErrorHandler
    
    Set Item = colMessageDataList.Item(Index)
    Exit Function
    
ErrorHandler:
    Set Item = Nothing
End Function

'bZ[Wf[^o^Ă邩H
Public Function IsDefined(Index As Variant) As Boolean
Dim md As MessageData

    On Error GoTo ErrorHandler
    Set md = colMessageDataList.Item(Index)
    IsDefined = True
    Exit Function
    
ErrorHandler:
    IsDefined = False
End Function

'bZ[Wf[^t@C烍[h
Public Sub Load(fname As String)
Dim FileNumber As Integer
Dim ret As Integer, line_num As Long
Dim line_buf As String, md As MessageData
Dim is_effect As Boolean
Dim sname As String, msg As String
Dim data_name As String
Dim err_msg As String

    'ʃf[^or퓬Ajf[^H
    If InStr(LCase$(fname), "effect.txt") > 0 _
        Or InStr(LCase$(fname), "animation.txt") > 0 _
    Then
        is_effect = True
    End If
    
    On Error GoTo ErrorHandler
    
    FileNumber = FreeFile
    Open fname For Input Access Read As #FileNumber
    
    line_num = 0
    
    Do While True
        data_name = ""
        
        Do
            If EOF(FileNumber) Then
                Close #FileNumber
                Exit Sub
            End If
            GetLine FileNumber, line_buf, line_num
        Loop While Len(line_buf) = 0
        
        If InStr(line_buf, ",") > 0 Then
            err_msg = "̂̐ݒ肪Ă܂B"
            Error 0
        End If
        
        data_name = line_buf
        
        If InStr(data_name, " ") > 0 Then
            err_msg = "̂ɔpXy[X͎gpo܂B"
            Error 0
        End If
        If InStr(data_name, "i") > 0 Or InStr(data_name, "j") > 0 Then
            err_msg = "̂ɑSpʂ͎gpo܂B"
            Error 0
        End If
        If InStr(data_name, """") > 0 Then
            err_msg = "̂""͎gpo܂B"
            Error 0
        End If
        
        'dĒ`ꂽf[^̏ꍇ
        If IsDefined(data_name) Then
            If Not is_effect Then
                'pCbgbZ[W̏ꍇ͌ォ`ꂽ̂D
                Delete data_name
                Set md = Add(data_name)
            Else
                'ʃf[^̏ꍇ͊̂̂ɒǉ
                Set md = Item(data_name)
            End If
        Else
            Set md = Add(data_name)
        End If
        
        With md
            GetLine FileNumber, line_buf, line_num
            Do While Len(line_buf) > 0
                ret = InStr(line_buf, ",")
                
                If ret < 2 Then
                    Error 0
                End If
                
                sname = Left$(line_buf, ret - 1)
                msg = Trim$(Mid$(line_buf, ret + 1))
                
                If Len(sname) = 0 Then
                    err_msg = "V`G[V̎w肪Ă܂B"
                    Error 0
                End If
                
                .AddMessage sname, msg
                
                If EOF(FileNumber) Then
                    Close #FileNumber
                    Exit Sub
                End If
                
                GetLine FileNumber, line_buf, line_num
            Loop
        End With
    Loop
    
ErrorHandler:
    'G[
    If line_num = 0 Then
        ErrorMessage fname & "J܂B"
    Else
        Close #FileNumber
        DataErrorMessage "", fname, line_num, line_buf, data_name
    End If
    TerminateSRC
End Sub

'ftHg̐퓬Ajf[^`
Public Sub AddDefaultAnimation()
Dim md As MessageData
    
    'Ajf[^pӂĂȂꍇ Data\System\animation.txt ǂݍ
    If Count() = 0 Then
        If FileExists(AppPath & "Data\System\animation.txt") Then
            Load AppPath & "Data\System\animation.txt"
        End If
    End If
    
    If IsDefined("ėp") Then
        Set md = Item("ėp")
    Else
        Set md = Add("ėp")
    End If
    
    With md
        If FindNormalLabel("퓬Aj_𔭓") > 0 Then
            If .SelectMessage("") = "" Then
                .AddMessage "", ""
            End If
        End If
        If FindNormalLabel("퓬Aj_؂蕥") > 0 Then
            If .SelectMessage("؂蕥") = "" Then
                .AddMessage "؂蕥", "؂蕥"
            End If
        End If
        If FindNormalLabel("퓬Aj_}") > 0 Then
            If .SelectMessage("}") = "" Then
                .AddMessage "}", "}"
            End If
        End If
        If FindNormalLabel("퓬Aj__~[") > 0 Then
            If .SelectMessage("_~[") = "" Then
                .AddMessage "_~[", "_~["
            End If
        End If
        If FindNormalLabel("퓬Aj_Cu") > 0 Then
            If .SelectMessage("C") = "" Then
                .AddMessage "C", "Cu"
            End If
        End If
        If FindNormalLabel("퓬Aj_⋋u") > 0 Then
            If .SelectMessage("⋋") = "" Then
                .AddMessage "⋋", "⋋u"
            End If
        End If
    End With
End Sub

