Attribute VB_Name = "Sound"
Option Explicit

' Copyright (C) 1997-2010 Kei Sakamoto
' {t@Cyі{t@Cgč쐬vO
' fzz֎~܂B

'aflʉĐp̃W[

'MCIpAPI
Declare Function mciSendString Lib "winmm.dll" Alias "mciSendStringA" _
    (ByVal lpstrCommand As String, ByVal lpstrReturnString As String, _
    ByVal uReturnLength As Long, ByVal hwndCallback As Long) As Long

'WAVEĐpAPI
Declare Function sndPlaySound Lib "winmm.dll" Alias "sndPlaySoundA" _
    (ByVal lpszSoundName As String, ByVal uFlags As Long) As Long

Public Const SND_SYNC = &H0         'ĐIA߂
Public Const SND_ASYNC = &H1        '֐sA߂
Public Const SND_NODEFAULT = &H2    'w肵WAVEt@CȂꍇA
                                    'ftHgWAVEt@CĐȂ
Public Const SND_MEMORY = &H4       't@CWAVEs
Public Const SND_LOOP = &H8         '~𖽗߂܂ōĐJԂB
Public Const SND_NOSTOP = &H10      'Wavet@CĐ̏ꍇAĐ𒆎~


'ݍĐĂafl̃t@C
Public BGMFileName As String
'afls[gĐH
Public RepeatMode As Boolean
'퓬ɂaflύXȂH
Public KeepBGM As Boolean
'{Xpaflt
Public BossBGM As Boolean

'Wavet@C̍ĐsH
Public IsWavePlayed As Boolean

'MIDIt@C̃T[`pX̏ĂH
Private IsMidiSearchPathInitialized As Boolean

'MIDIĐ@̎i
Public UseMCI As Boolean
Public UseDirectMusic As Boolean

'WAVĐ@̎i
Public UseDirectSound As Boolean

'MP3Đ̉
Public MP3Volume As Integer

'DirectMusicpϐ
Private DXObject As DirectX7
Private DMLoader As DirectMusicLoader
Private DMPerformance As DirectMusicPerformance
Private DMSegment As DirectMusicSegment

'VBMP3.dll̏ĂH
Private IsMP3Supported As Boolean

'DirectSoundpϐ
Private DSObject As DirectSound
Private DSBuffer As DirectSoundBuffer


'afl̍ĐJn
Public Sub StartBGM(bgm_name As String, Optional ByVal is_repeat_mode As Boolean = True)
Dim fname As String, fname0 As String, fname2 As String
Dim i As Integer

    'aflŒ蒆H
    If KeepBGM Then
        Exit Sub
    End If
    
    '_~[̃t@CH
    If Len(bgm_name) < 5 Then
        Exit Sub
    End If
    
    't@C̖{̕𔲂o
    fname0 = Left$(bgm_name, Len(bgm_name) - 4)
    If InStr2(fname0, "\") > 0 Then
        fname0 = Mid$(fname0, InStr2(fname0, "\") + 1)
    End If
    
    'afltłΉtp
    If Len(BGMFileName) > 0 Then
        If InStr(BGMFileName, "\" & fname0 & ".") > 0 Then
            If BGMStatus() = "playing" Then
                Exit Sub
            End If
        End If
    End If
    
    't@C
    bgm_name = "(" & bgm_name & ")"
    fname = SearchMidiFile(bgm_name)
    
    't@CH
    If Len(fname) = 0 Then
        Exit Sub
    End If
    
    'tXgbv
    StopBGM
    
    'aflɃoG[V΃_őI
    i = 1
    If InStr(fname, ScenarioPath) > 0 Then
        'ViIɃt@Cꍇ̓oG[VViÎݑI
        Do
            i = i + 1
            fname2 = SearchMidiFile("(" & fname0 & "(" & Format$(i) & ")" & Right$(fname, 4) & ")")
        Loop While InStr(fname2, ScenarioPath) > 0
    Else
        'łȂΗI
        Do
            i = i + 1
            fname2 = SearchMidiFile("(" & fname0 & "(" & Format$(i) & ")" & Right$(fname, 4) & ")")
        Loop While fname2 <> ""
    End If
    
    i = Int(((i - 1) * Rnd) + 1)
    If i > 1 Then
        fname = SearchMidiFile("(" & fname0 & "(" & Format$(i) & ")" & Right$(fname, 4) & ")")
    End If
    
    'aflAtH
    RepeatMode = is_repeat_mode
    
    't@C[hAtJn
    LoadBGM fname
    
    's[gĐs߂̃^C}[N
    MainForm.Timer1.Enabled = True
End Sub

'afl̃t@Cǂݍ
Private Sub LoadBGM(fname As String)
Dim ret As Long, cmd As String
Dim mp3_data As InputInfo
    
    't@C̎ނɉs
    Select Case LCase$(Right$(fname, 4))
        Case ".mid"
            'MIDIt@C
            
            'MIDIt̂߂āH
            If Not UseDirectMusic And Not UseMCI Then
                'DirectMusic݂̏
                InitDirectMusic
            End If
            
            'Zbg
            ResetBGM
            
            'DirectMusicgH
            If UseDirectMusic Then
                't@C[h
                On Error GoTo ErrorHandler
                
                Set DMSegment = DMLoader.LoadSegment(fname)
                If Err.Number <> 0 Then
                    ErrorMessage "LoadSegment failed (" & Format$(Err.Number) & ")"
                End If
                
                Call DMSegment.SetStandardMidiFile
                If Err.Number <> 0 Then
                    ErrorMessage "SetStandardMidiFile failed (" & Format$(Err.Number) & ")"
                End If
                Call DMPerformance.SetMasterAutoDownload(True)
                If Err.Number <> 0 Then
                    ErrorMessage "SetMasterAutoDownload failed (" & Format$(Err.Number) & ")"
                End If
                
                '[vt̐ݒ
                'JԂ͈͂ݒ
                Call DMSegment.SetLoopPoints(0, 0)
                If Err.Number <> 0 Then
                    ErrorMessage "SetLoopPoints failed (" & Format$(Err.Number) & ")"
                End If
                'JԂ񐔂ݒ
                If RepeatMode Then
                    Call DMSegment.SetRepeats(-1)
                Else
                    Call DMSegment.SetRepeats(0)
                End If
                If Err.Number <> 0 Then
                    ErrorMessage "SetRepeats failed (" & Format$(Err.Number) & ")"
                End If
                
                'tJn
                Call DMPerformance.PlaySegment(DMSegment, 0, 0)
                If Err.Number <> 0 Then
                    ErrorMessage "PlaySegment failed (" & Format$(Err.Number) & ")"
                End If
                
                BGMFileName = fname
                Exit Sub
            End If
            
            If GetWinVersion() >= 5 Then
                cmd = " type mpegvideo alias bgm wait"
            Else
                cmd = " type sequencer alias bgm wait"
            End If
            
        Case ".wav"
            'WAVEt@C
            cmd = " type waveaudio alias bgm wait"
            
        Case ".mp3"
            'MP3t@C
            
            'VBMP3.dll
            If Not IsMP3Supported Then
                InitVBMP3
                
                If Not IsMP3Supported Then
                    'VBMP3.dllps\
                    Exit Sub
                End If
            End If
            
            't~
            Call vbmp3_stop
            't@C
            Call vbmp3_close
            
            't@Cǂݍ
            If vbmp3_open(fname, mp3_data) Then
'                'JԂĐ͎GȂ悤tF[hAEg
'                If RepeatMode Then
'                    Call vbmp3_setFadeOut(1)
'                Else
'                    Call vbmp3_setFadeOut(0)
'                End If
                
                'tJn
                Call vbmp3_play
                BGMFileName = fname
            End If
            Exit Sub
            
        Case Else
            'T|[g̃t@C`
            Exit Sub
    End Select
    
    't@CJ
    cmd = "open " & Chr$(34) & fname & Chr$(34) & cmd
    ret = mciSendString(cmd, vbNullString, 0, 0)
    If ret <> 0 Then
        'JȂ
        Exit Sub
    End If
    
    'tJn
    ret = mciSendString("play bgm", vbNullString, 0, 0)
    If ret <> 0 Then
        'tłȂ
        ret = mciSendString("close bgm wait", vbNullString, 0, 0)
        Exit Sub
    End If
    
    'tĂBGM̃t@CL^
    BGMFileName = fname
    Exit Sub
    
ErrorHandler:
    If UseDirectMusic Then
        'DirectMusicgpłȂꍇMCIgăgC
        UseDirectMusic = False
        UseMCI = True
        LoadBGM fname
    End If
End Sub

'aflX^[g
Public Sub RestartBGM()
Dim ret As Long
    
    '~łȂΉȂ
    If BGMStatus() <> "stopped" Then
        Exit Sub
    End If
    
    'X^[g
    Select Case LCase$(Right$(BGMFileName, 4))
        Case ".mid"
            'MIDIt@C
            If UseMCI Then
                ret = mciSendString("seek bgm to start wait", vbNullString, 0, 0)
                If ret <> 0 Then
                    Exit Sub
                End If
                ret = mciSendString("play bgm", vbNullString, 0, 0)
            End If
        Case ".wav"
            'WAVEt@C
            ret = mciSendString("seek bgm to start wait", vbNullString, 0, 0)
            If ret <> 0 Then
                Exit Sub
            End If
            ret = mciSendString("play bgm", vbNullString, 0, 0)
        Case ".mp3"
            'MP3t@C
            If vbmp3_getState(ret) = 2 Then
                Call vbmp3_restart
            Else
                Call vbmp3_play
            End If
    End Select
End Sub

'afl~
Public Sub StopBGM(Optional ByVal by_force As Boolean)
Dim ret As Long
    
    'aflŒ蒆H
    If Not by_force And KeepBGM Then
        Exit Sub
    End If
    
    'Iɒ~̂łȂΉtłȂȂɂȂ
    If Not by_force And Len(BGMFileName) = 0 Then
        Exit Sub
    End If
    
    Select Case LCase$(Right$(BGMFileName, 4))
        Case ".mid", ""
            'MIDIt@C
            If UseDirectMusic Then
                't~
                On Local Error Resume Next
                Call DMPerformance.Stop(DMSegment, Nothing, 0, 0)
                If Err.Number <> 0 Then
                    ErrorMessage "DMPerformance.Stop failed (" & Format$(Err.Number) & ")"
                End If
            Else
                't~
                ret = mciSendString("stop bgm wait", vbNullString, 0, 0)
                't@C
                ret = mciSendString("close bgm wait", vbNullString, 0, 0)
            End If
        Case ".wav"
            'WAVEt@C
            't~
            ret = mciSendString("stop bgm wait", vbNullString, 0, 0)
            't@C
            ret = mciSendString("close bgm wait", vbNullString, 0, 0)
        Case ".mp3"
            'MP3t@C
            't~
            Call vbmp3_stop
            't@C
            Call vbmp3_close
    End Select
    
    BGMFileName = ""
    RepeatMode = False
    
    's[gĐs߂̃^C}[~
    MainForm.Timer1.Enabled = False
End Sub

'lhch(MCIgpꍇ̂)
Private Sub ResetBGM()
Dim ret As Long
Dim fname As String, cmd As String

    '̎ނɉpMIDIt@CI
    Select Case MidiResetType
        Case "GM"
            If UseDirectMusic Then
                'DirectMusicgGMZbg\
                On Error GoTo ErrorHandler
                Call DMPerformance.Reset(0)
                Exit Sub
            End If
            fname = AppPath & "Midi\Reset(GM).mid"
        Case "GS"
            fname = AppPath & "Midi\Reset(GS).mid"
        Case "XG"
            fname = AppPath & "Midi\Reset(XG).mid"
        Case Else
            Exit Sub
    End Select
    
    't@CƂH
    If Not FileExists(fname) Then
        Exit Sub
    End If
    
    BGMFileName = ""
    
    If UseDirectMusic Then
        'DirectMusicgꍇ
        On Error GoTo ErrorHandler
        
        't@C[h
        Set DMSegment = DMLoader.LoadSegment(fname)
        
        'MIDIĐ̂ߊep[^ݒ
        Call DMSegment.SetStandardMidiFile
        Call DMPerformance.SetMasterAutoDownload(True)
        Call DMSegment.SetLoopPoints(0, 0)
        Call DMSegment.SetRepeats(0)
        
        'ZbgpMIDIt@C̉tJn
        Call DMPerformance.PlaySegment(DMSegment, 0, 0)
        
        'tI܂ő҂
        Do While DMPerformance.IsPlaying(DMSegment, Nothing)
            DoEvents
        Loop
        
        't~
        Call DMPerformance.Stop(DMSegment, Nothing, 0, 0)
    Else
        'MCIgꍇ
        
        't@CI[v
        cmd = "open " & Chr$(34) & fname & Chr$(34) & " type sequencer alias bgm wait"
        ret = mciSendString(cmd, vbNullString, 0, 0)
        If ret <> 0 Then
            Exit Sub
        End If
        
        'ZbgpMIDIt@Ct
        ret = mciSendString("play bgm wait", vbNullString, 0, 0)
        
        't@CN[Y
        ret = mciSendString("close bgm wait", vbNullString, 0, 0)
    End If
    
    Exit Sub
    
ErrorHandler:
    'DirectMusicgpɃG[̂MCIg
    UseDirectMusic = False
    UseMCI = True
End Sub

'aflĐH
Private Function BGMStatus() As String
Dim retstr As String, ret As Long, sec As Long

    'afltłȂ΋󕶎Ԃ
    If Len(BGMFileName) = 0 Then
        Exit Function
    End If
    
    Select Case LCase$(Right$(BGMFileName, 4))
        Case ".mid", ""
            'MIDIt@C
            If UseDirectMusic Then
                'DirectMusicgꍇ
                On Local Error Resume Next
                If DMPerformance.IsPlaying(DMSegment, Nothing) Then
                    BGMStatus = "playing"
                Else
                    BGMStatus = "stopped"
                End If
                If Err.Number <> 0 Then
                    ErrorMessage "DMPerformance.IsPlaying failed (" & Format$(Err.Number) & ")"
                End If
            Else
                'MCIgꍇ
                
                'ʂۑ̈m
                retstr = Space$(120)
                
                'Đ󋵂Q
                ret = mciSendString("status bgm mode", retstr, 120, 0)
                If ret <> 0 Then
                    Exit Function
                End If
                
                'APǏʂNULL^[~lCg
                ret = InStr(retstr, Chr$(0))
                BGMStatus = Left$(retstr, ret - 1)
            End If
            
        Case ".wav"
            'WAVEt@C
            
            'ʂۑ̈m
            retstr = Space$(120)
            
            ret = mciSendString("status bgm mode", retstr, 120, 0)
            If ret <> 0 Then
                Exit Function
            End If
            
            'APǏʂNULL^[~lCg
            ret = InStr(retstr, Chr$(0))
            BGMStatus = Left$(retstr, ret - 1)
            
        Case ".mp3"
            'MP3̍ĐԂƍĐԂ̎擾
            ret = vbmp3_getState(sec)
            
            Select Case ret
                Case 0
                    '~
                    BGMStatus = "stopped"
                Case 1
                    'Đ
                    BGMStatus = "playing"
                Case 2
                    'ꎞ~
                    BGMStatus = "stopped"
            End Select
    End Select
End Function

'aflύX (w肵aflłɉtȂȂɂȂ)
Public Sub ChangeBGM(bgm_name As String)
Dim fname As String, fname2 As String
    
    'aflŒ蒆H
    If KeepBGM Or BossBGM Then
        Exit Sub
    End If
    
    't@CH
    If Len(bgm_name) < 5 Then
        Exit Sub
    End If
    
    't@C̖{̕𔲂o
    fname = Left$(bgm_name, Len(bgm_name) - 4)
    If InStr2(fname, "\") > 0 Then
        fname = Mid$(fname, InStr2(fname, "\") + 1)
    End If
    
    'ɓMIDItĂ΂̂܂܉t
    If Len(BGMFileName) > 0 Then
        If InStr(BGMFileName, "\" & fname & ".") > 0 Then
            Exit Sub
        End If
    End If
    
    'ԍႢH
    If Len(BGMFileName) > 5 Then
        fname2 = Left$(BGMFileName, Len(BGMFileName) - 4)
        If InStr2(fname2, "\") > 0 Then
            fname2 = Mid$(fname2, InStr2(fname2, "\") + 1)
        End If
        If Len(fname2) > 4 Then
            Select Case Right$(fname2, 3)
                Case "(2)", "(3)", "(4)", "(5)", "(6)", "(7)", "(8)", "(9)"
                    fname2 = Left$(fname2, Len(fname2) - 3)
            End Select
        End If
        If fname = fname2 Then
            Exit Sub
        End If
    End If
    
    'JԂtɐݒ
    RepeatMode = True
    
    'tJn
    StartBGM bgm_name
End Sub


'DirectMusic̏
Public Sub InitDirectMusic()
Dim port_id As Integer
Dim portcaps As DMUS_PORTCAPS
Dim i As Integer

    On Error GoTo ErrorHandler
    
    'tOݒ
    UseDirectMusic = True
    UseMCI = False
    
    'DirectXIuWFNg쐬
    If DXObject Is Nothing Then
        Set DXObject = CreateDirectXObject()
    End If
    
    'Loader쐬
    Set DMLoader = DXObject.DirectMusicLoaderCreate
    
    'T[`pXݒ(svH)
    Call DMLoader.SetSearchDirectory(AppPath & "Midi")
    
    'Performance쐬
    Set DMPerformance = DXObject.DirectMusicPerformanceCreate
    
    'Performance
    'DirectSoundƕp鎞́Aŏ̈
    'DirectSound̃IuWFNgĂ
    Call DMPerformance.Init(DSObject, MainForm.hwnd)
    
    'MIDIꗗ쐬
    CreateMIDIPortListFile
    
    '|[gݒ
    port_id = StrToLng(ReadIni("Option", "MIDIPortID"))
    
    'gp|[gԍw肳Ăꍇ
    If port_id > 0 Then
        If port_id > DMPerformance.GetPortCount Then
            ErrorMessage "MIDIPortIDɐMIDI|[gݒ肳Ă܂B"
            End
        End If
        
        Call DMPerformance.SetPort(port_id, 1)
        Exit Sub
    End If
    
    'w肪Ȃ̂SRCŌ
    
    'MIDI}bp[΂g
    For i = 1 To DMPerformance.GetPortCount
        If InStr(DMPerformance.GetPortName(i), "MIDI }bp[") > 0 _
           Or InStr(DMPerformance.GetPortName(i), "MIDI Mapper") > 0 _
        Then
            Call DMPerformance.SetPort(i, 1)
            Exit Sub
        End If
    Next
    
    '܂͊OMIDI{
    For i = 1 To DMPerformance.GetPortCount
        Call DMPerformance.GetPortCaps(i, portcaps)
        If portcaps.lFlags And DMUS_PC_EXTERNAL Then
            Call DMPerformance.SetPort(i, 1)
            Exit Sub
        End If
    Next
    
    'XGΉn[h{
    For i = 1 To DMPerformance.GetPortCount
        Call DMPerformance.GetPortCaps(i, portcaps)
        If portcaps.lFlags And DMUS_PC_XGINHARDWARE Then
            Call DMPerformance.SetPort(i, 1)
            Exit Sub
        End If
    Next
    
    'GSΉn[h{
    For i = 1 To DMPerformance.GetPortCount
        Call DMPerformance.GetPortCaps(i, portcaps)
        If portcaps.lFlags And DMUS_PC_GSINHARDWARE Then
            Call DMPerformance.SetPort(i, 1)
            Exit Sub
        End If
    Next
    
    'XGΉ\tg{
    For i = 1 To DMPerformance.GetPortCount
        If InStr(DMPerformance.GetPortName(i), "XG ") > 0 Then
            Call DMPerformance.SetPort(i, 1)
            Exit Sub
        End If
    Next
    
    'GSΉ\tg{
    For i = 1 To DMPerformance.GetPortCount
        If InStr(DMPerformance.GetPortName(i), "GS ") > 0 Then
            Call DMPerformance.SetPort(i, 1)
            Exit Sub
        End If
    Next
    
    'GMΉn[h{
    For i = 1 To DMPerformance.GetPortCount
        Call DMPerformance.GetPortCaps(i, portcaps)
        If portcaps.lFlags And DMUS_PC_GMINHARDWARE Then
            Call DMPerformance.SetPort(i, 1)
            Exit Sub
        End If
    Next
    
    '߂ăftHg|[gg
    Call DMPerformance.SetPort(-1, 1)
    
    Exit Sub
    
ErrorHandler:
    
    'DirectMusicɃG[̂MCIg
    UseDirectMusic = False
    UseMCI = True
End Sub

'DirectXIuWFNg쐬
Private Function CreateDirectXObject() As DirectX7
Dim new_obj As New DirectX7

    Set CreateDirectXObject = new_obj
End Function

'p\MIDÏꗗ쐬
Private Sub CreateMIDIPortListFile()
Dim f As Integer, i As Integer
Dim pname As String

    On Error GoTo ErrorHandler
    
    f = FreeFile
    Open AppPath & "Midi\MIDIXg.txt" For Output Access Write As #f
    
    Print #f, ";DirectMusicŗp\MIDĨXgłB"
    Print #f, ";Src.iniMIDIPortIDɎgp̔ԍw肵ĉB"
    Print #f, ""
    
    'e|[ĝ̖Q
    For i = 1 To DMPerformance.GetPortCount
        pname = DMPerformance.GetPortName(i)
        If InStr(pname, "[") > 0 Then
            pname = Left$(pname, InStr(pname, "[") - 1)
        End If
        Print #f, Format$(i) & ":" & pname
    Next
    
    Close #f
    
ErrorHandler:
    'G[
End Sub


'VBMP3
Private Sub InitVBMP3()
    If Not FileExists(AppPath & "VBMP3.dll") Then
        Exit Sub
    End If
    
    Call vbmp3_init
    
    Call vbmp3_setVolume(MP3Volume, MP3Volume)
    
    IsMP3Supported = True
End Sub


'eMiditH_w肳ꂽMIDIt@C
Public Function SearchMidiFile(midi_name As String) As String
Dim fname As String, fname_mp3 As String
Static scenario_midi_dir_exists As Boolean
Static extdata_midi_dir_exists As Boolean
Static extdata2_midi_dir_exists As Boolean
Static is_mp3_available As Boolean
Dim i As Integer, j As Integer, num As Integer
Dim buf As String, buf2 As String
    
    '߂ĎsۂɁAetH_MiditH_邩`FbN
    If Not IsMidiSearchPathInitialized Then
        If Len(ScenarioPath) > 0 Then
            If Len(Dir$(ScenarioPath & "Midi", vbDirectory)) > 0 Then
                scenario_midi_dir_exists = True
            End If
        End If
        If Len(ExtDataPath) > 0 Then
            If Len(Dir$(ExtDataPath & "Midi", vbDirectory)) > 0 Then
                extdata_midi_dir_exists = True
            End If
        End If
        If Len(ExtDataPath2) > 0 Then
            If Len(Dir$(ExtDataPath2 & "Midi", vbDirectory)) > 0 Then
                extdata2_midi_dir_exists = True
            End If
        End If
        
        'MP3t\ǂׂĂ
        If FileExists(AppPath & "VBMP3.dll") Then
            is_mp3_available = True
        End If
        
        IsMidiSearchPathInitialized = True
    End If
    
    '_~[̃t@CH
    If Len(midi_name) < 5 Then
        Exit Function
    End If
    
    '1ƂēnꂽXgƂĈA珇MIDI
    num = ListLength(midi_name)
    i = 1
    Do While i <= num
        'Xy[X܂ރt@Cւ̑Ή
        buf = ""
        For j = i To num
            buf2 = LCase(ListIndex(midi_name, j))
            
            'Ŝ()ň͂܂Ăꍇ()O
            If Left$(buf2, 1) = "(" _
                And Right$(buf2, 1) = ")" _
            Then
                buf2 = Mid$(buf2, 2, Len(buf2) - 2)
            End If
            
            buf = buf & " " & buf2
        
            If Right$(buf, 4) = ".mid" Then
                Exit For
            End If
        Next
        buf = Trim$(buf)
        
        'MP3t@CꍇMIDIt@C̑MP3t@Cg
        If is_mp3_available Then
            fname_mp3 = Left$(buf, Len(buf) - 4) & ".mp3"
        End If
        
        'tpXł̎wH
        If InStr(buf, ":") = 2 Then
            If is_mp3_available Then
                If FileExists(fname_mp3) Then
                    SearchMidiFile = fname_mp3
                    Exit Function
                End If
            End If
            If FileExists(buf) Then
                SearchMidiFile = buf
            End If
            Exit Function
        End If
        
        'ViIMiditH_
        If scenario_midi_dir_exists Then
            If is_mp3_available Then
                fname = ScenarioPath & "Midi\" & fname_mp3
                If FileExists(fname) Then
                    SearchMidiFile = fname
                    Exit Function
                End If
            End If
            
            fname = ScenarioPath & "Midi\" & buf
            If FileExists(fname) Then
                SearchMidiFile = fname
                Exit Function
            End If
        End If
        
        'ExtDataPathMiditH_
        If extdata_midi_dir_exists Then
            If is_mp3_available Then
                fname = ExtDataPath & "Midi\" & fname_mp3
                If FileExists(fname) Then
                    SearchMidiFile = fname
                    Exit Function
                End If
            End If
            
            fname = ExtDataPath & "Midi\" & buf
            If FileExists(fname) Then
                SearchMidiFile = fname
                Exit Function
            End If
        End If
        
        'ExtDataPath2MiditH_
        If extdata2_midi_dir_exists Then
            If is_mp3_available Then
                fname = ExtDataPath2 & "Midi\" & fname_mp3
                If FileExists(fname) Then
                    SearchMidiFile = fname
                    Exit Function
                End If
            End If
            
            fname = ExtDataPath2 & "Midi\" & buf
            If FileExists(fname) Then
                SearchMidiFile = fname
                Exit Function
            End If
        End If
        
        '{̑MiditH_
        If is_mp3_available Then
            fname = AppPath & "Midi\" & fname_mp3
            If FileExists(fname) Then
                SearchMidiFile = fname
                Exit Function
            End If
        End If
        
        fname = AppPath & "Midi\" & buf
        If FileExists(fname) Then
            SearchMidiFile = fname
            Exit Function
        End If
        i = j + 1
    Loop
End Function

'MIDIt@C̃T[`pXZbg
Public Sub ResetMidiSearchPath()
    IsMidiSearchPathInitialized = False
End Sub


'aflɊ蓖ĂꂽMIDIt@CԂ
Public Function BGMName(bgm_name As String) As String
Dim vname As String

    'RenameBGMR}hMIDIt@Cݒ肳Ă΂gp
    vname = "BGM(" & bgm_name & ")"
    If IsGlobalVariableDefined(vname) Then
        BGMName = GlobalVariableList.Item(vname).StringValue
        Exit Function
    End If
    
    'łȂSrc.iniŐݒ肳Ăt@Cgp
    BGMName = ReadIni("BGM", bgm_name)
    
    'Src.iniłݒ肳ĂȂΕW̃t@Cgp
    If BGMName = "" Then
        BGMName = bgm_name & ".mid"
    End If
End Function


'DirectSound̏
Public Sub InitDirectSound()
    'On Error GoTo ErrorHandler
    Exit Sub
    
    'tOݒ
    UseDirectSound = True
    
    'DirectXIuWFNg쐬
    If DXObject Is Nothing Then
        Set DXObject = CreateDirectXObject()
    End If
    
    'DirectSoundIuWFNg쐬
    Set DSObject = DXObject.DirectSoundCreate("")
    
    'TEhfoCX̋xݒ
    DSObject.SetCooperativeLevel MainForm.hwnd, DSSCL_PRIORITY
    
    Exit Sub
    
ErrorHandler:
    
    UseDirectSound = False
End Sub

'Wavet@CĐ
Public Sub PlayWave(wave_name As String)
Dim ret As Long
Dim fname As String
Dim mp3_data As InputInfo
Static init_play_wave As Boolean
Static scenario_sound_dir_exists As Boolean
Static extdata_sound_dir_exists As Boolean
Static extdata2_sound_dir_exists As Boolean

    '߂ĎsۂɁAetH_SoundtH_邩`FbN
    If Not init_play_wave Then
        If Len(Dir$(ScenarioPath & "Sound", vbDirectory)) > 0 Then
            scenario_sound_dir_exists = True
        End If
        If Len(ExtDataPath) > 0 Then
            If Len(Dir$(ExtDataPath & "Sound", vbDirectory)) > 0 Then
                extdata_sound_dir_exists = True
            End If
        End If
        If Len(ExtDataPath2) > 0 Then
            If Len(Dir$(ExtDataPath2 & "Sound", vbDirectory)) > 0 Then
                extdata2_sound_dir_exists = True
            End If
        End If
        init_play_wave = True
    End If
    
    'ȃt@C
    Select Case LCase$(wave_name)
        Case "-.wav", "-.mp3"
            'ĐLZ
            Exit Sub
        Case "null.wav"
            'WAVEĐ~
            StopWave
            Exit Sub
        Case "null.mp3"
            'MP3Đ~
            If LCase$(Right$(BGMFileName, 4)) = ".mp3" Then
                StopBGM True
            Else
                't~
                Call vbmp3_stop
                't@C
                Call vbmp3_close
            End If
            Exit Sub
    End Select
    
    'etH_`FbN
    
    'ViISoundtH_
    If scenario_sound_dir_exists Then
        fname = ScenarioPath & "Sound\" & wave_name
        If FileExists(fname) Then
            GoTo FoundWave
        End If
    End If
    
    'ExtDataPathSoundtH_
    If extdata_sound_dir_exists Then
        fname = ExtDataPath & "Sound\" & wave_name
        If FileExists(fname) Then
            GoTo FoundWave
        End If
    End If
    
    'ExtDataPath2SoundtH_
    If extdata2_sound_dir_exists Then
        fname = ExtDataPath2 & "Sound\" & wave_name
        If FileExists(fname) Then
            GoTo FoundWave
        End If
    End If
    
    '{̑SoundtH_
    fname = AppPath & "Sound\" & wave_name
    If FileExists(fname) Then
        GoTo FoundWave
    End If
    
    'Ε\LH
    fname = wave_name
    If FileExists(fname) Then
        GoTo FoundWave
    End If
    
    'Ȃ
    Exit Sub
    
FoundWave:
    
    If LCase$(Right$(fname, 4)) = ".mp3" Then
        'ʉMP3t@C
        
        'VBMP3.dll
        If Not IsMP3Supported Then
            InitVBMP3
            
            If Not IsMP3Supported Then
                'VBMP3.dllps\
                Exit Sub
            End If
        End If
        
        'MP3Đ~
        If LCase$(Right$(BGMFileName, 4)) = ".mp3" Then
            StopBGM True
        Else
            't~
            Call vbmp3_stop
            't@C
            Call vbmp3_close
        End If
        
        't@Cǂݍ
        If vbmp3_open(fname, mp3_data) Then
            'ĐJn
            Call vbmp3_play
        End If
    ElseIf UseDirectSound Then
        'DirectSoundgꍇ
        
        Dim dsbd As DSBUFFERDESC
        Dim wf As WAVEFORMATEX
        
        'Đ̏ꍇ͍ĐXgbv
        If Not DSBuffer Is Nothing Then
            DSBuffer.Stop
            Set DSBuffer = Nothing
        End If
        
        'TEhobt@WAVt@Cǂݍ
        dsbd.lFlags = _
            DSBCAPS_CTRLFREQUENCY Or DSBCAPS_CTRLPAN _
            Or DSBCAPS_CTRLVOLUME Or DSBCAPS_STATIC
        Set DSBuffer = DSObject.CreateSoundBufferFromFile(fname, dsbd, wf)
        
        'WAVEĐ
        DSBuffer.Play DSBPLAY_DEFAULT
    Else
        'APIgꍇ
        
        'WAVEĐ
        ret = sndPlaySound(fname, SND_ASYNC + SND_NODEFAULT)
    End If
    
    'ʉĐ̃tO𗧂Ă
    IsWavePlayed = True
End Sub

'Wavet@C̍ĐI
Public Sub StopWave()
Dim ret As Long
    
    If UseDirectSound Then
        If Not DSBuffer Is Nothing Then
            DSBuffer.Stop
        End If
    Else
        ret = sndPlaySound(vbNullString, 0)
    End If
End Sub


'{W[̉s
Public Sub FreeSoundModule()
    'BGMt̒~
    KeepBGM = False
    BossBGM = False
    StopBGM True
    
    '
    ResetBGM
    
    'WAVEt@CĐ̒~
    StopWave
    
    'DirectMusic̉
    If UseDirectMusic Then
        't~
        DMPerformance.CloseDown
        
        'IuWFNg̉
        Set DMLoader = Nothing
        Set DMPerformance = Nothing
        Set DMSegment = Nothing
    End If
    
    'DirectSound̉
    If UseDirectSound Then
        'IuWFNg̉
        Set DSObject = Nothing
        Set DSBuffer = Nothing
    End If
    
    'DirectX̉
    Set DXObject = Nothing
    
    'VBMP3.DLL̉
    If IsMP3Supported Then
        Call vbmp3_stop
        Call vbmp3_free
    End If
End Sub

